package hellojpa;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class AllStudents {
	private static String DatabaseName = "jdbc:derby:openjpa-database2;create=true";
	private static final String UserName = "";
	private static final String UserPass = "";
	public static final String Driver = "org.apache.derby.jdbc.EmbeddedDriver";
	static Connection dbcon = null;
	static Statement stm = null;
	static PreparedStatement prstm = null;
	static ResultSet rez = null;

	private static void connectToDB() throws DatabaseException {
		// Load the Oracle JDBC driver
		try {
			Class.forName(Driver);
		} catch (ClassNotFoundException ex) {
			throw new DatabaseException("Can not load the JDBC driver class",
					ex);
		}

		// Establish connection to the database server
		try {
			dbcon = DriverManager.getConnection(DatabaseName, UserName,
					UserPass);
		} catch (SQLException sqlex) {
			throw new DatabaseException("Can not establish DB connection",
					sqlex);
		}
		System.out.println("Connected to DB.");
	}

	private static void disconnectFromDB() {
		try {
			if (dbcon != null) {
				dbcon.close();

			}
		} catch (SQLException sqlex) {
		}
		System.out.println("Disconnected from DB.");
	}

	public static void FindId() {

		String query = 
			"SELECT" +
			"   student.name as studentname, " +
			"   student.zodiacsign as zodiac, " +
			"   grade.name as grade " +
			"FROM student " +
			"INNER JOIN grade ON student.course_id = grade.ID";
				//" " + "WHERE s.course_id=g.ID";

		try {
			// Create a statement for executing SQL commands
			try {
				stm = dbcon.createStatement();
			} catch (SQLException sqlex) {
				throw new DatabaseException("Can not create statement", sqlex);
			}

			// Execute the SQL command
			try {
				rez = stm.executeQuery(query);
			} catch (SQLException sqlex) {
				throw new DatabaseException("Error executing SQL query", sqlex);
			}
			try {

				System.out.println("Name of student " + "Zodiac" + "  Grade");
				System.out.println("---------------------------------");
				while (rez.next()) {
					String stName = rez.getString("studentname");
					String stzod = rez.getString("zodiac");
					String grade = rez.getString("grade");

					System.out.println(stName + "\t\t" + stzod + "\t"
							+ grade);
				}
			} catch (SQLException sqlex) {
				throw new DatabaseException("Database error", sqlex);
			}
		} catch (DatabaseException dbex) {
			dbex.printStackTrace();
		} finally {
			if (rez != null) {
				try {
					rez.close();
				} catch (SQLException sqlex) {
				}
			}
			if (stm != null) {
				try {
					stm.close();
				} catch (SQLException sqlex) {
				}
			}
			if (dbcon != null) {
				try {
					dbcon.close();
				} catch (SQLException sqlex) {
				}
			}
		}

	}

	/**
	 * @param args
	 * @throws DatabaseException
	 */
	public static void main(String[] args) throws DatabaseException {
		// TODO Auto-generated method stub

		connectToDB();
		FindId();
		disconnectFromDB();

	}
}
